/*
 * ImageGrid.java
 *
 * Created on 02 July 2003, 22:23
 */

/**
 *
 * @author  Deadmeat
 */

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import javax.swing.*;

public class ImageGrid extends JPanel implements MouseListener
{
    
    private Vector _imgCells;
    private int _selection;
    private int _nCells;
    private int _rowLength;
    
    /** Creates a new instance of ImageGrid */
    public ImageGrid(int rows, int columns)
    {
        int i;
        ImageCell currCell;
        
        _nCells = columns * rows;
        _rowLength = columns;
        
        // Grid layout
        setLayout(new GridLayout(rows, columns));
        
        // Add the cells
        _imgCells = new Vector(_nCells, 1);
        
        // Pregen some images
        short[] data = new short[256*256];
        for (i=0; i<256; i++)
        {
            for (int j=0; j<256; j++)
            {
                data[i*256+j] = (short)(4*Math.sqrt(i*i+j*j));
            }
        }
        
        // Gen the grid of cells
        for (i=0; i<_nCells; i++)
        {
            currCell = new ImageCell();
            currCell.setData(data, 256, 256);
            currCell.addMouseListener(this);
            add(currCell);
            _imgCells.add(currCell);
        }
        
        // Selection stuff
        _selection = -1;
        
        // Add mouse listener
        addMouseListener(this);
    }
    
    public void mouseClicked(MouseEvent e)
    {
        int newSelection;
        
        ImageCell source = (ImageCell)e.getSource();
        newSelection = _imgCells.indexOf(source);
        if (newSelection != _selection)
        {
            ((ImageCell)_imgCells.elementAt(newSelection)).setActive();
            if (_selection != -1)
            {
                ((ImageCell)_imgCells.elementAt(_selection)).setInactive();
            }
            _selection = newSelection;
        }
    }
    
    public void mouseEntered(MouseEvent e)
    {
    }
    
    public void mouseExited(MouseEvent e)
    {
    }
    
    public void mousePressed(MouseEvent e)
    {
    }
    
    public void mouseReleased(MouseEvent e)
    {
    }
    
}
